#include "rsigold.h"

#include <string.h>

/* Tile-engine info */

typedef struct
{
   unsigned char x,y;
} tilePosition;

typedef struct
{
   unsigned char sx,sy;
   tilePosition position[256];
} tileIndex;

tileIndex rsi_gold_index =
   { 32,32,
      {
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
/* 10 */
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
/* 20 */
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
/* 30 */
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  1, 0 }, {  2, 0 },
         {  3, 0 }, {  4, 0 }, {  5, 0 }, {  6, 0 }, {  7, 0 },
/* 40 */
         {  8, 0 }, {  9, 0 }, {  0, 1 }, {  1, 1 }, {  2, 1 },
         {  3, 1 }, {  4, 1 }, {  5, 1 }, {  6, 1 }, {  7, 1 },
/* 50 */
         {  8, 1 }, {  9, 1 }, {  0, 2 }, {  1, 2 }, {  2, 2 },
         {  3, 2 }, {  4, 2 }, {  5, 2 }, {  6, 2 }, {  7, 2 },
/* 60 */
         {  8, 2 }, {  9, 2 }, {  0, 3 }, {  1, 3 }, {  2, 3 },
         {  3, 3 }, {  4, 3 }, {  5, 3 }, {  6, 3 }, {  7, 3 },
/* 70 */
         {  8, 3 }, {  9, 3 }, {  0, 4 }, {  1, 4 }, {  2, 4 },
         {  3, 4 }, {  4, 4 }, {  5, 4 }, {  6, 4 }, {  7, 4 },
/* 80 */
         {  8, 4 }, {  9, 4 }, {  0, 5 }, {  1, 5 }, {  2, 5 },
         {  3, 5 }, {  4, 5 }, {  5, 5 }, {  6, 5 }, {  7, 5 },
/* 90 */
         {  8, 5 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  3, 3 }, {  4, 3 }, {  5, 3 },
/* 100 */
         {  6, 3 }, {  7, 3 }, {  8, 3 }, {  9, 3 }, {  0, 4 },
         {  1, 4 }, {  2, 4 }, {  3, 4 }, {  4, 4 }, {  5, 4 },
/* 110 */
         {  6, 4 }, {  7, 4 }, {  8, 4 }, {  9, 4 }, {  0, 5 },
         {  1, 5 }, {  2, 5 }, {  3, 5 }, {  4, 5 }, {  5, 5 },
/* 120 */
         {  6, 5 }, {  7, 5 }, {  8, 5 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
/* 130 */
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 }, {  0, 0 },
         {  0, 0 }
      }
   };

BITMAP *
rsiAllocBitmap(char *string)
{
   int width,height;
   int w;
   BITMAP *bitmap;

   w = 0;
   width = 0;
   height = 1;

   for ( ; *string!='\0' ; string++)
      switch (*string)
      {
      case '\n':
           height++;
           width = (w>width ? w : width );
           w = 0;
           break;
      default:
           w++;
      }

   width = (w>width ? w : width );

   bitmap = create_bitmap(rsi_gold_index.sx * width, rsi_gold_index.sy * height);

   return bitmap;
}

void
rsiFreeBitmap(BITMAP *bitmap)
{
   destroy_bitmap(bitmap);
}

int
rsiWriteString(BITMAP *bitmap,char *string)
{
   int px,py;
   int length;

   px = py = 0;

   for ( ; *string!='\0'; string++ )
      switch (*string)
      {
      case '\n':
         py += rsi_gold_index.sy;
         px = 0;
         break;
      default:
         blit
         (
            &rsi_gold_font, bitmap,
            rsi_gold_index.position[*string].x * rsi_gold_index.sx ,
            rsi_gold_index.position[*string].y * rsi_gold_index.sy ,
            px,py,
            rsi_gold_index.sx,
            rsi_gold_index.sy
        );

        px += rsi_gold_index.sx;
   }
}


