#ifndef RSIGOLD_H
#define RSIGOLD_H

/****************************************************************
 * Red Sector Font Library for Allegro
 * Written by Nigel Stewart / Inspire Media
 * Version 1.0b  Nov 5, 1997
 *
 * This library is a recycling of a favorite old Amiga-demo font
 * by Red Sector, back in the 80's.  If you ever come across
 * someone with an Amiga 500, ask 'em if they have Red Sector
 * Mega-Demo... It was cool for it's time... Really!
 *
 * The font consists of a 320x192 bitmap of 32x32 characters in
 * 16 colours.  Index zero is for background and numbers 16-255
 * are unused.  You may find it handy to copy the bitmap and
 * rebase it somewhere else to mix it with other palette's.
 *
 * I've provided some Allegro-compatible functions to make
 * it convenient to use this library in your own project.
 * This is the basis for a tiling engine which I may or may
 * not ever finish...  I'm planning to convert my (large)
 * collection of C64 and DOS fonts first.. ;)
 *
 * Note that these functions are carriage-return friendly...
 *
 * Nigel Stewart  nigels@anon.nymserver.com
 ****************************************************************/

#include <allegro.h>

/* This is the bitmap font data, along with default palette */

extern BITMAP rsi_gold_font;
extern PALLETE rsi_blue_pal;

/* Extra palette's for variety */

extern PALLETE rsi_gold_pal;
extern PALLETE rsi_green_pal;
extern PALLETE rsi_purple_pal;
extern PALLETE rsi_red_pal;
extern PALLETE rsi_white_pal;

/*******************************************************
 * rsiAllocBitmap() - Allocate a bitmap to fit 'string'
 * rsiFreeBitmap()  - Release memory used by string bitmap
 *******************************************************/

BITMAP *rsiAllocBitmap(char *string);
void    rsiFreeBitmap(BITMAP *bitmap);

/***************************************************
 * rsiWriteString() - Write a string into a bitmap
 ***************************************************/

int     rsiWriteString(BITMAP *buffer,char *string);

#endif


